; #########################################################################

; Install-Font v1.0.0.0 by Pone@ecad.org, CCC Consulting.
; A MASM32 program to Extract a Font from Internal Resources and install it.

; #########################################################################

.386
.model flat, stdcall
option casemap :none   ; case sensitive

; #########################################################################
        
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\advapi32.inc
include \masm32\include\Shell32.inc
include \masm32\COM\include\Oaidl.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\Shell32.lib

SH32_Folders PROTO :DWORD, :DWORD, :DWORD
ResExtractFile PROTO :DWORD, :DWORD, :DWORD, :DWORD  
UpdateRegistry PROTO

; #########################################################################

    .data
szCopyright     db "Copyright  Pone@ecad.org 2002, All Rights Reserved.",0
szMsgTitle      db "Font Installer",0
szSuccess       db "You have successfully installed Install font to your computer.",0  
szFailedGV      db "Failed Get Version.",0Dh,"Call Network Engineering for manual installation of font file.", 0  
szFailedGF      db "Failed Get Folder Location.",0Dh,"Call Network Engineering for manual installation of font file.", 0  
szFailedRE      db "Failed Font Extraction.",0Dh  
                db "Probably cause is current Font is in use.",0Dh
                db "Please Re-Boot and Re-Run Installer.  Thank you!",0Dh
                db "If this happens twice, then Call Network Engineering for manual installation of font file.", 0  
szFailedUR      db "Failed Update Registry.",0Dh,"Call Network Engineering for manual installation of font file.", 0  
szResMarker     db "BINFILE",0    
szResourceName  db "FontFile",0
szDestFileName  db "\Install.ttf",0
szW95           db "C:\WINDOWS\FONTS",0    
szDestination   db MAX_PATH + 1 dup(0)
szNT            db " NT",0
szAdder         db "\CurrentVersion\Fonts\",0
szValueName     db "Install (TrueType)",0    
szSubKey        db "Software\Microsoft\Windows",sizeof szNT + sizeof szAdder dup(0)

; #########################################################################

    .data?

;When available, comment out this structure.
;OSVERSIONINFOEX STRUCT
;dwOSVersionInfoSize   DWORD      ?
;dwMajorVersion        DWORD      ?
;dwMinorVersion        DWORD      ?
;dwBuildNumber         DWORD      ?
;dwPlatformId          DWORD      ?
;szCSDVersion          BYTE 128 dup (?)
;End of OSVERSIONINFOA
;Start of EX extensions.
;wServicePackMajor     WORD       ?
;wServicePackMinor     WORD       ?
;wSuiteMask            WORD       ?
;bProductType          BYTE       ?
;bReserved             BYTE       ?
;OSVERSIONINFOEX ENDS

l_OSVERSIONINFO OSVERSIONINFOEX <>
hInstance       dd ?

; #########################################################################

    .code
start: 

invoke GetModuleHandle, NULL
mov hInstance, eax

mov l_OSVERSIONINFO.dwOSVersionInfoSize, SIZEOF OSVERSIONINFO
invoke GetVersionEx, addr l_OSVERSIONINFO
.if eax == FALSE
    invoke MessageBox,0,addr szFailedGV,addr szMsgTitle,MB_OK
    jmp The_End
.else
    .if l_OSVERSIONINFO.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS
        .if l_OSVERSIONINFO.dwMinorVersion == 0
            jmp W95
        .endif
    .endif
    .if l_OSVERSIONINFO.dwPlatformId == VER_PLATFORM_WIN32_NT
        invoke lstrcat, addr szSubKey, addr szNT
    .endif
.endif
jmp WXX
        
W95:
invoke lstrcat, addr szDestination, addr szW95
invoke lstrcat, addr szDestination, addr szDestFileName
jmp CHECK

WXX:
Invoke SH32_Folders,0,CSIDL_FONTS,ADDR szDestination
.if eax==0
    invoke lstrcat, addr szDestination, addr szDestFileName
.else
    invoke MessageBox,0,addr szFailedGF,addr szMsgTitle,MB_OK
    jmp The_End
.endif


CHECK:
;Over-write for now.
invoke RemoveFontResource,addr szDestination
invoke SendMessage,HWND_BROADCAST,WM_FONTCHANGE,NULL,NULL

COPYOUT:
        invoke ResExtractFile,hInstance,addr szResourceName,addr szResMarker,addr szDestination
        .if eax == ERROR_SUCCESS
            invoke UpdateRegistry
            invoke AddFontResource,addr szDestination
            invoke SendMessage,HWND_BROADCAST,WM_FONTCHANGE,NULL,NULL
            invoke MessageBox,0,addr szSuccess,addr szMsgTitle,MB_OK
            jmp The_End
        .elseif eax == -1
            ;Use GetLastError to get more useful information.
        .elseif eax == -2       
            ;Size mis-match error.  Target file was deleted.  
        .endif
        invoke MessageBox,0,addr szFailedRE,addr szMsgTitle,MB_OK
The_End:
        invoke ExitProcess, NULL

; #########################################################################

SH32_Folders proc l_HWND:DWORD, CSIDL_ID:DWORD, DPFname:DWORD
;l_HWND - In, Optional, otherwise use NULL
;CSIDL_ID - In, See CSIDL_XX... for Folder requested.
;DPFname - Out, szVariable for Drive\Path\FileName.

.data?
ppidl   dd ?
ppIM    dd ?
.code  
Invoke SHGetSpecialFolderLocation, l_HWND, CSIDL_ID, addr ppidl
.if eax == NOERROR
    Invoke SHGetPathFromIDList, ppidl, DPFname
    Invoke SHGetMalloc, addr ppIM
    coinvoke ppIM, IMalloc, Free, addr ppidl
    coinvoke ppIM, IMalloc, Release
    xor eax,eax
.else
    ;eax, returns error number 
.endif
ret
SH32_Folders endp

; #########################################################################

UpdateRegistry proc
.data
dwReserved      equ 0

.data?
hkResult        dd ?
dwDisposition   dd ?
dwLength        dd ?
;l_Security_Attributes SECURITY_ATTRIBUTES <>

.code
;Prep work.

;invoke RtlZeroMemory, OFFSET l_Security_Attributes, SIZEOF l_Security_Attributes
;mov l_Security_Attributes.nLength, sizeof l_Security_Attributes

invoke lstrcat, addr szSubKey, addr szAdder

invoke lstrlen,addr szDestFileName + 1
mov dwLength,eax

;Add Font to Font List.
invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
                      ADDR szSubKey,
                      dwReserved,
                      NULL,
                      REG_OPTION_NON_VOLATILE,
                      KEY_WRITE,
                      NULL,
                      ADDR hkResult,
                      ADDR dwDisposition                          
.if eax == ERROR_SUCCESS
    invoke RegSetValueEx,hkResult,addr szValueName,NULL,REG_SZ,addr szDestFileName + 1,dwLength
    invoke RegCloseKey,ADDR hkResult
.else
    invoke MessageBox,0,addr szFailedUR,addr szMsgTitle,MB_OK
    jmp The_End    
.endif
ret
UpdateRegistry endp

; #########################################################################

ResExtractFile proc hInst:DWORD, Resource:DWORD, ResMarker:DWORD, Destination:DWORD
LOCAL hRsrc:DWORD
LOCAL hResource:DWORD
LOCAL dwResSize:DWORD
LOCAL hFile:DWORD
LOCAL dwWritten:DWORD
LOCAL lpfResource:DWORD

invoke FindResource,hInst,Resource,ResMarker
.if eax == NULL
    not eax
.else
    mov hRsrc,eax
    invoke LoadResource,hInst,hRsrc
    .if eax == NULL
        not eax
    .else
        mov hResource,eax
        invoke SizeofResource,hInst,hRsrc
        mov dwResSize,eax
        invoke LockResource,hResource
        mov lpfResource,eax
        
        ;Currently setup to overwrite, if present.
        invoke CreateFile,Destination,GENERIC_WRITE, 0, NULL, 
               CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL 
        .if eax == INVALID_HANDLE_VALUE
            ;User can use GetLastError
        .else   ;File is present.
            mov hFile, eax
            invoke WriteFile,hFile,lpfResource,dwResSize,ADDR dwWritten,NULL
            mov eax,dwResSize
            .if eax == dwWritten
                invoke CloseHandle,hFile
                mov eax,ERROR_SUCCESS
            .else    
                invoke DeleteFile,Destination
                mov eax,-2
            .endif
        .endif
    .endif   
.endif
ret
ResExtractFile endp

; #########################################################################
end start







